package com.ruoyi.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.ruoyi.pay.domain.bo.PaySubPlanBo;
import com.ruoyi.pay.domain.vo.PaySubPlanVo;
import com.ruoyi.pay.domain.PaySubPlan;
import com.ruoyi.pay.mapper.PaySubPlanMapper;
import com.ruoyi.pay.service.IPaySubPlanService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 订阅套餐Service业务层处理
 *
 * @author ruoyi
 * @date 2025-05-13
 */
@RequiredArgsConstructor
@Service
public class PaySubPlanServiceImpl implements IPaySubPlanService {

    private final PaySubPlanMapper baseMapper;

    /**
     * 查询订阅套餐
     */
    @Override
    public PaySubPlanVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询订阅套餐列表
     */
    @Override
    public TableDataInfo<PaySubPlanVo> queryPageList(PaySubPlanBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<PaySubPlan> lqw = buildQueryWrapper(bo);
        Page<PaySubPlanVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询订阅套餐列表
     */
    @Override
    public List<PaySubPlanVo> queryList(PaySubPlanBo bo) {
        LambdaQueryWrapper<PaySubPlan> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<PaySubPlan> buildQueryWrapper(PaySubPlanBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<PaySubPlan> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getName()), PaySubPlan::getName, bo.getName());
        lqw.eq(bo.getPrice() != null, PaySubPlan::getPrice, bo.getPrice());
        lqw.eq(StringUtils.isNotBlank(bo.getDescription()), PaySubPlan::getDescription, bo.getDescription());
        return lqw;
    }

    /**
     * 新增订阅套餐
     */
    @Override
    public Boolean insertByBo(PaySubPlanBo bo) {
        PaySubPlan add = BeanUtil.toBean(bo, PaySubPlan.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改订阅套餐
     */
    @Override
    public Boolean updateByBo(PaySubPlanBo bo) {
        PaySubPlan update = BeanUtil.toBean(bo, PaySubPlan.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(PaySubPlan entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除订阅套餐
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
